library(raster)
library(data.table)
library(magrittr)
library(fs)
library(doParallel)
library(foreach)
registerDoParallel(parallel::detectCores() - 1)

path_in<-"/../"
path_out<-"/../"
variable<-"tasmin"; remapmode<-"remapbil"
target<-paste0(path_in,"grid_1km_laea")

inventory<-readRDS(paste0(path_in,"CORDEX/",variable,"_inventory.RDS"))

#-------------- remap original CORDEX 0.11 to the target grid ---------------------------
# All projections are remapped from rotated pole lat/lon to a common regular grid of 1 km centred on Trentino South Tyrol
# bilinear mapping - remapbil
# first-order conservative mapping for pr - remapcon

foreach(i = 1:nrow(inventory),
        .inorder=F,
        .packages=c("data.table","magrittr")
  ) %dopar%{
    
    files_glob <- inventory$list_files[i][[1]]
    for(j in seq_along(files_glob)){
      
    file_in<- files_glob[j]
    file_out<-path(path_out, 
                   paste0(variable,"_day"), 
                   path_file(file_in))
    cdo_call<-paste0("cdo ",remapmode,",",target," ",file_in," ",file_out)
    system(cdo_call)
    }
  }
